Loading...
Searching...
No Matches
Sensor.h File Reference
`#include <memory>`
`#include "BaseDevice.h"`
`#include "Condition.h"`
`#include "HueCommandAPI.h"`
`#include "TimePattern.h"`
`#include <nlohmann/json.hpp>`
Include dependency graph for Sensor.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes

class | hueplusplus::Sensor
| Class for generic or unknown sensor types. More...
class | hueplusplus::CreateSensor
| Parameters for creating a new Sensor. More...
class | hueplusplus::sensors::DaylightSensor
| Daylight sensor to detect sunrise and sunset. More...

## Namespaces

namespace | hueplusplus
| Namespace for the hueplusplus library.
namespace | hueplusplus::sensors
| Classes for specific sensor types.

## Enumerations

enum class | hueplusplus::Alert { hueplusplus::none , hueplusplus::select , hueplusplus::lselect }
| Specifies light alert modes. More...

## Functions

std::string | hueplusplus::alertToString (Alert alert)
| Convert alert to string form.
Alert | hueplusplus::alertFromString (const std::string &s)
| Convert string to Alert enum.
detail::ConditionHelper< bool > | hueplusplus::sensors::makeCondition (const DaylightSensor &sensor)
template<typename SensorT , detail::void_t< decltype(std::declval< const SensorT >().getLastUpdated())> * = nullptr>
detail::ConditionHelper< time::AbsoluteTime > | hueplusplus::sensors::makeConditionLastUpdate (const SensorT &sensor)
template<typename ButtonSensor , detail::void_t< decltype(std::declval< const ButtonSensor >().getButtonEvent())> * = nullptr>
detail::ConditionHelper< int > | hueplusplus::sensors::makeCondition (const ButtonSensor &sensor)
template<typename PresenceSensor , detail::void_t< decltype(std::declval< const PresenceSensor >().getPresence())> * = nullptr>
detail::ConditionHelper< bool > | hueplusplus::sensors::makeCondition (const PresenceSensor &sensor)
template<typename TemperatureSensor , detail::void_t< decltype(std::declval< const TemperatureSensor >().getPresence())> * = nullptr>
detail::ConditionHelper< int > | hueplusplus::sensors::makeCondition (const TemperatureSensor &sensor)

## Detailed Description

Copyright Notice
Copyright (C) 2020 Stefan Herbrechtsmeier - developer
Copyright (C) 2020 Jan Rogall - developer
This file is part of hueplusplus.

hueplusplus is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

hueplusplus is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with hueplusplus. If not, see http://www.gnu.org/licenses/.